// -*- c++ -*-
#ifndef _GLIBMM_INTERFACE_H
#define _GLIBMM_INTERFACE_H

/* $Id: interface.h,v 1.11 2002/02/25 02:21:14 murrayc Exp $ */

/* interface.h
 *
 * Copyright 2001 Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h> //Needed by dynamic_casts in callbacks.

namespace Glib
{

#ifndef DOXYGEN_SHOULD_SKIP_THIS
class Interface_Class;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

//There is no base GInterface struct in Glib, though there is G_TYPE_INTERFACE enum value.
class Interface : virtual public ObjectBase
{
public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Interface       CppObjectType;
  typedef Interface_Class CppClassType;
  //typedef GTypeInterface  BaseObjectType;
  typedef GTypeInterface  BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  Interface();
  Interface(GObject *castitem);
  virtual ~Interface();

  //void add_interface(GType gtype_implementer);

  // Hook for translating API
  //static Glib::Interface* wrap_new(GTypeInterface*);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type();
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  inline GObject* gobj()             { return gobject_; }
  inline const GObject* gobj() const { return gobject_; }

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType interface_class;

  Interface(const Interface&);
  Interface& operator=(const Interface&); // not implemented
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

protected:
  //GTypeInterface* ginterface_
  //Each interface will have it's own name - e.g. ginterface_treemodel_
  //This means that there will be no clash when using virtual inheritance with MI.
};

RefPtr<ObjectBase> wrap_interface(GObject* object, bool take_copy = false);

} /* namespace Glib */

#endif /* _GLIBMM_INTERFACE_H */

