// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ARROW_H
#define _GTKMM_ARROW_H

#include <glibmm.h>

/* $Id: arrow.hg,v 1.12 2002/04/02 13:25:13 daniel Exp $ */

/* arrow.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/misc.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkArrow GtkArrow;
typedef struct _GtkArrowClass GtkArrowClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Arrow_Class; } // namespace Gtk
namespace Gtk
{

/** Arrow widget
 * This is intended for use where a directional arrow (in one of the
 * four cardinal directions) is desired. As such, it has very limited
 * functionality and basically only draws itself in a particular
 * direction and
 * with a particular shadow type.
 *
 * {Gtk::Arrow::} will fill any space alloted to it, but since it is inherited
 * from {Gtk::Misc::}, it can be padded and/or aligned, to fill exactly
 * the space the programmer desires.
 *
 * @ingroup Widgets
 */

class Arrow : public Misc {
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Arrow CppObjectType;
  typedef Arrow_Class CppClassType;
  typedef GtkArrow BaseObjectType;
  typedef GtkArrowClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Arrow();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType arrow_class_;

  Arrow(const Arrow&);
  Arrow& operator=(const Arrow&); // not implemented

protected:
  explicit Arrow(GtkArrow* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkArrow* gobj()             { return (GtkArrow*)(gobject_); }
  const GtkArrow* gobj() const { return (GtkArrow*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:


  /** Creates an arrow.
   * Must specify the direction with {arrow_type} and the shadow with
   * {shadow_type}.
   */
  explicit Arrow(ArrowType arrow_type, ShadowType shadow_type);
  

  // Changes the direction and shadow of an arrow.
  
  void set(ArrowType arrow_type, ShadowType shadow_type);

  Glib::PropertyProxy<ArrowType> property_arrow_type();

  Glib::PropertyProxy<ShadowType> property_shadow_type();


};


} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Arrow */
  Gtk::Arrow* wrap(GtkArrow* object, bool take_copy = false);
}
#endif /* _GTKMM_ARROW_H */

