// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ASPECTFRAME_H
#define _GTKMM_ASPECTFRAME_H

#include <glibmm.h>

/* $Id: aspectframe.hg,v 1.14 2002/04/01 16:19:33 murrayc Exp $ */

/* aspectframe.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/frame.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkAspectFrame GtkAspectFrame;
typedef struct _GtkAspectFrameClass GtkAspectFrameClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class AspectFrame_Class; } // namespace Gtk
namespace Gtk
{

/** The Gtk::AspectFrame is useful when you want pack a widget so that it can resize but always retains the same aspect ratio.
 * For instance, one might be drawing a small preview of a larger image. Because it derives from Gtk::Frame, it can draw a label and a frame around the child. The frame will be "shrink-wrapped" to the size of the child.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class AspectFrame : public Frame
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef AspectFrame CppObjectType;
  typedef AspectFrame_Class CppClassType;
  typedef GtkAspectFrame BaseObjectType;
  typedef GtkAspectFrameClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~AspectFrame();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType aspectframe_class_;

  AspectFrame(const AspectFrame&);
  AspectFrame& operator=(const AspectFrame&); // not implemented

protected:
  explicit AspectFrame(GtkAspectFrame* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkAspectFrame* gobj()             { return (GtkAspectFrame*)(gobject_); }
  const GtkAspectFrame* gobj() const { return (GtkAspectFrame*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:


public:

  explicit AspectFrame(const Glib::ustring &label,
		  float xalign, float yalign,
		  float ratio = 1.0, bool obey_child = false);

  
  void set(float xalign, float yalign, float ratio, int obey_child);

  Glib::PropertyProxy<float> property_xalign();

  Glib::PropertyProxy<float> property_yalign();

  Glib::PropertyProxy<float> property_ratio();

  Glib::PropertyProxy<bool> property_obey_child();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::AspectFrame */
  Gtk::AspectFrame* wrap(GtkAspectFrame* object, bool take_copy = false);
}
#endif /* _GTKMM_ASPECTFRAME_H */

