// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_BOX_H
#define _GTKMM_BOX_H

#include <glibmm.h>

/* $Id: box.hg,v 1.29 2002/04/02 13:25:13 daniel Exp $ */


/* box.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtk/gtkbox.h>
#include <gtkmm/container.h>
#include <glibmm/helperlist.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkBox GtkBox;
typedef struct _GtkBoxClass GtkBoxClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Box_Class; } // namespace Gtk
#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkVBox GtkVBox;
typedef struct _GtkVBoxClass GtkVBoxClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class VBox_Class; } // namespace Gtk
#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkHBox GtkHBox;
typedef struct _GtkHBoxClass GtkHBoxClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class HBox_Class; } // namespace Gtk
namespace Gtk
{

class Box;

namespace Box_Helpers
{

class Child : protected _GtkBoxChild
{
private:
  Child& operator=(const Child&); //Not implemented.
  Child(const Child&); //Not implemented.

public:
  inline _GtkBoxChild* gobj() {return (this);}
  inline const _GtkBoxChild* gobj() const {return (this);}

  Widget* get_widget() const;

  inline guint16 get_padding() const   { return (gobj()->padding); }
  inline bool get_expand() const       { return (gobj()->expand); }
  inline bool get_fill() const         { return (gobj()->fill); }
  inline bool get_pack() const         { return (gobj()->pack); }

  void set_options(bool expand,bool fill,guint padding);
  void set_pack(PackType pack);

protected:
  Child(void* do_not_derive_this);

  inline GtkBox* parent()
    {return GTK_BOX(gobj()->widget->parent);}
  void redraw();
};

class Element
{
public:
 Element(Widget& widget,
          bool expand=true,
          bool fill=true,
          guint padding=0,
          PackType pack=PACK_START)
      : widget_(&widget),expand_(expand),fill_(fill),
        padding_(padding),pack_(pack)
    {}

  Widget* widget_;
  bool expand_;
  bool fill_;
  guint padding_;
  PackType pack_;
};

typedef Element StartElem;

struct EndElem : public Element
{
  EndElem(Widget& widget,
          bool expand=true,
          bool fill=true,
          guint padding=0)
      : Element (widget,expand,fill,padding,PACK_END)
    {}
};

 
class BoxList : public Glib::HelperList< Child*, const Element, Glib::List_Iterator< Child* > >
{
public:
  BoxList();
  explicit BoxList(GtkBox* gparent);
  BoxList(const BoxList& src);
  virtual ~BoxList() {}

  BoxList& operator=(const BoxList& src);

  typedef Glib::HelperList< Child*, const Element,  Glib::List_Iterator< Child* > > type_base;

  GtkBox* gparent();
  const GtkBox* gparent() const;

  virtual GList*& glist() const;      // front of list

  virtual void erase(iterator start, iterator stop);
  virtual iterator erase(iterator);  //Implented as custom or by LIST_CONTAINER_REMOVE
  virtual void remove(const_reference); //Implented as custom or by LIST_CONTAINER_REMOVE

  value_type front() const     { return *begin(); }
  value_type back() const      { return *(--end()); }

  /// This is order n. (use at own risk)
  value_type operator[](size_type l) const;

public:
  iterator insert(iterator position, element_type& e); //custom-implemented.

  template <class InputIterator>
  inline void insert(iterator position, InputIterator first, InputIterator last)
  {
    for(;first != last; ++first)
      position = insert(position, *first);
  }

 inline void push_front(element_type& e)
    { insert(begin(), e); }
  inline void push_back(element_type& e)
    { insert(end(), e); }


  iterator find(const_reference c);
  iterator find(Widget&);

  
virtual void remove(Widget& w); //Implented as custom or by LIST_CONTAINER_REMOVE

        // Non-standard
        void reorder(iterator loc,iterator pos);
  };


} /* namespace Box_Helpers */

/** Abstract base class for horizontal and vertical boxes, which organize a variable number of widgets into a rectangular area.
 * This is an abstract class and it defers choice of which
 * way the widgets are packed to the screen to the derived classes.
 * It provides a common interface for inserting widgets
 * to a box indepenently of how it is shown in the screen.
 *
 * Gtk::Box uses a notion of packing. Packing refers to adding widgets with reference to a particular position in a Gtk::Container. There are two reference positions: the start and the end of the box. For a GtkVBox, the start is defined as the top of the box and the end is defined as the bottom. For a GtkHBox the start is defined as the left side and the end is defined as the right side.
 * Use repeated calls to Gtk::pack_start() to pack widgets into a GtkBox from start to end. Use Gtk::Box::pack_end() to add widgets from end to start. You may intersperse these calls and add widgets from both ends of the same Gtk::Box.
 *
 * Because Gtk::Box is a Gtk::Container, you may also use Gtl::Container::add() to insert widgets, and they will be packed as if with Gtk::Box::pack_start(). Use Gtk::Container::remove() to remove widgets.
 *
 * Use Gtk::Box::set_homogeneous() to specify whether or not all children of the GtkBox occupy the same amount of space.
 * Use Gtk::Box::set_spacing() to determine the minimum space placed between all children in the GtkBox.
 * Use Gtk::Box::reorder_child() to move a child widget to a different place in the box.
 * Use Gtk::Box::set_child_packing() to reset the expand, fill, and padding attributes of any GtkBox child. Use Gtk::Box::query_child_packing() to query these fields.
 */

class Box : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Box CppObjectType;
  typedef Box_Class CppClassType;
  typedef GtkBox BaseObjectType;
  typedef GtkBoxClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Box();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType box_class_;

  Box(const Box&);
  Box& operator=(const Box&); // not implemented

protected:
  explicit Box(GtkBox* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkBox* gobj()             { return (GtkBox*)(gobject_); }
  const GtkBox* gobj() const { return (GtkBox*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

  
public:
  typedef Box_Helpers::BoxList BoxList;

protected:
  Box();
public:

  
  /** Left side insert a widget to a box.
   * The expand argument to {pack_start()} or {pack_end()}
   * controls whether the widgets are laid out in the box to {fill} in all
   * the extra space in the box so the box is expanded to fill the area
   * alloted to it ({\key true}). Or the box is shrunk to just fit the widgets
   * ({\key false}).  Setting {expand} to {\key false} will allow you
   * to do right and left
   * justifying of your widgets.  Otherwise, they will all expand to fit in
   * the box, and the same effect could be achieved by using only one of
   * {pack_start()} or {pack_end()} functions.
   * 
   * The fill argument to the {pack_start()}/{pack_end()} functions control whether the
   * extra space is allocated to the objects themselves ({\key true}), or as extra
   * padding in the box around these objects ({\key false}). It only has an effect
   * if the {expand} argument is also {\key true}.
   * 
   * The difference between spacing (set when the box is created)
   * and {padding} (set when elements are packed), spacing is added between
   * objects, and {padding} is added on either side of an object.
   */
  void pack_start(Widget& child, bool expand = true, bool fill = true, guint padding = 0);

  //: right side insert a widget to a box.
  
  void pack_end(Widget& child, bool expand = true, bool fill = true, guint padding = 0);

  //: Change box child sizing policy.
  //- allows setting homongeneous afterwards. This is usually given on 
  //- {VBox::VBox()} or {Gtk::HBox::HBox()}
  
  void set_homogeneous(bool homogeneous = true);
  
  /** Returns whether the box is homogeneous (all children are the
   * same size). See gtk_box_set_homogeneous ().
   * @return %TRUE if the box is homogeneous.
   */
  bool get_homogeneous() const;

  //: Change spacing between children.
  
  void set_spacing(int spacing);
  
  /** Gets the value set by gtk_box_set_spacing().
   * @return Spacing between children.
   */
  int get_spacing() const;

  //: Reorder children by integer index.
  
  void reorder_child(Widget& child, int pos);

// Horrible interface use new one
// void query_child_packing             (Widget &child,
//					bool         *expand,
//					bool         *fill,
//					guint        *padding,
//					PackType  *pack_type) const;
// void set_child_packing               (Widget &child,
//					bool         expand,
//					bool         fill,
//					guint        padding,
//					PackType  pack_type);

  BoxList& children();
  const BoxList& children() const;

  Glib::PropertyProxy<int> property_spacing();

  Glib::PropertyProxy<bool> property_homogeneous();


protected:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  mutable BoxList children_proxy_;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


};


/** Vertical Box for laying widgets in a vertical row.
 * You should create these objects, but it is more confortable to
 * pass around pointers of Gtk::Box. All the methods that do anything
 * are in {Gtk::Box::} class and this allows you to later change
 * the direction of the box, when there's no dependencies to hbox and
 * vbox classes.
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class VBox : public Box
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef VBox CppObjectType;
  typedef VBox_Class CppClassType;
  typedef GtkVBox BaseObjectType;
  typedef GtkVBoxClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~VBox();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType vbox_class_;

  VBox(const VBox&);
  VBox& operator=(const VBox&); // not implemented

protected:
  explicit VBox(GtkVBox* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkVBox* gobj()             { return (GtkVBox*)(gobject_); }
  const GtkVBox* gobj() const { return (GtkVBox*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:

  //: Create a vertical packing box.
  //- @see Gtk::HBox::HBox()}.
  explicit VBox(bool homogeneous = false, int spacing = 0);
  

};

/** Horizontal Box for laying widgets in a horizontal row.
 * You should create these objects, but it is more confortable to
 * pass around pointers of Gtk::Box. All the methods that do anything
 * are in {Gtk::Box::} class and this allows you to later change
 * the direction of the box, when there's no dependencies to hbox and
 * vbox classes.
 *
 * Use the Gtk::Box packing interface to determine the arrangement,
 * spacing, width, and alignment of Gtk::HBox children.
 *
 * All children are allocated the same height.
 *
 * @see Gtk::Box
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class HBox : public Box
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef HBox CppObjectType;
  typedef HBox_Class CppClassType;
  typedef GtkHBox BaseObjectType;
  typedef GtkHBoxClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~HBox();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType hbox_class_;

  HBox(const HBox&);
  HBox& operator=(const HBox&); // not implemented

protected:
  explicit HBox(GtkHBox* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkHBox* gobj()             { return (GtkHBox*)(gobject_); }
  const GtkHBox* gobj() const { return (GtkHBox*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:

  /** Creates a new horizontal box
   * The homogeneous argument controls whether each object
   * in the box has the same
   * size (i.e. the same width in an HBox, or the same height in a
   * VBox). If it is set, the expand argument to the pack routines
   * is always turned on.
   *
   * spacing determines width between children
   */
  explicit HBox(bool homogeneous = false, int spacing = 0);
  

};


} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Box */
  Gtk::Box* wrap(GtkBox* object, bool take_copy = false);
}
namespace Glib
{
  /** @relates Gtk::VBox */
  Gtk::VBox* wrap(GtkVBox* object, bool take_copy = false);
}
namespace Glib
{
  /** @relates Gtk::HBox */
  Gtk::HBox* wrap(GtkHBox* object, bool take_copy = false);
}
#endif /* _GTKMM_BOX_H */

