// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_FRAME_H
#define _GTKMM_FRAME_H

#include <glibmm.h>

/* $Id: frame.hg,v 1.25 2002/04/02 13:25:15 daniel Exp $ */

/* frame.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <gtkmm/bin.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkFrame GtkFrame;
typedef struct _GtkFrameClass GtkFrameClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Frame_Class; } // namespace Gtk
namespace Gtk
{

/** The Frame widget surrounds its single child with a decorative frame and an optional label.
 * If present, the label is drawn in a gap in the top side of the frame. The position of the label can be controlled with set_label_align().
 * @ingroup Widgets
 * @ingroup Containers
 */

class Frame : public Bin
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Frame CppObjectType;
  typedef Frame_Class CppClassType;
  typedef GtkFrame BaseObjectType;
  typedef GtkFrameClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Frame();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType frame_class_;

  Frame(const Frame&);
  Frame& operator=(const Frame&); // not implemented

protected:
  explicit Frame(GtkFrame* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkFrame* gobj()             { return (GtkFrame*)(gobject_); }
  const GtkFrame* gobj() const { return (GtkFrame*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
  virtual void compute_child_allocation(GtkAllocation * allocation);

  //Default Signal Handlers::


private:

public:

  Frame();
  explicit Frame(const Glib::ustring& label);

  /** Adds a label to appear in the top edge of the frame.
   * Label alignment defaults to the upper left corner of the frame.
   */
  
  void set_label(const Glib::ustring& str);
  void remove_label();
  
  /** If the frame's label widget is a Gtk::Label, return the
   * text in the label widget. (The frame will have a Gtk::Label
   * for the label widget if a non-<tt>0</tt> argument was passed
   * to new().)
   * @return The text in the label, or <tt>0</tt> if there
   * was no label widget or the lable widget was not
   * a Gtk::Label. This value must be freed with g_free().
   */
  Glib::ustring get_label() const;

  
  /** Set the label widget for the frame. This is the widget that
   * will appear embedded in the top edge of the frame as a
   * title.
   * @param label_widget The new label widget.
   */
  void set_label_widget(Widget& label_widget);
  
  /** Retrieves the label widget for the frame. See
   * set_label_widget().
   * @return The label widget, or <tt>0</tt> if there is none.
   */
  Widget* get_label_widget();

  /** Sets the alignment of a frame's label.
   * @param xalign - sets the horizontal label position and should be between 0 (left) and 1.0 (right).
   * @param yalign - sets the vertical label position.
   */
  
  void set_label_align(float xalign = 0.0, float yalign = 0.5);
  
  /** Retrieves the X and Y alignment of the frame's label. See
   * set_label_align().
   * @param xalign Location to store X alignment of frame's label, or <tt>0</tt>.
   * @param yalign Location to store X alignment of frame's label, or <tt>0</tt>.
   */
  void get_label_align(float& xalign, float& yalign);


  /** Sets shadow type of the frame.
   * The possible choices are: {\enum
   *  GTK_SHADOW_NONE,GTK_SHADOW_IN,GTK_SHADOW_OUT,GTK_SHADOW_ETCHED_IN,
   *   GTK_SHADOW_ETCHED_OUT}
   *
   * declaration of the enum ShadowType can be found from gtkenums.h
   */
  
  void set_shadow_type(ShadowType type);
  
  /** Retrieves the shadow type of the frame. See
   * set_shadow_type().
   * @return The current shadow type of the frame.
   */
  ShadowType get_shadow_type() const;

  
  Glib::PropertyProxy<Glib::ustring> property_label();

  Glib::PropertyProxy<double> property_label_xalign();

  Glib::PropertyProxy<double> property_label_yalign();

  //_WRAP_PROPERTY("shadow", ShadowType) //deprecated
  Glib::PropertyProxy<ShadowType> property_shadow_type();

  Glib::PropertyProxy<Widget*> property_label_widget();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Frame */
  Gtk::Frame* wrap(GtkFrame* object, bool take_copy = false);
}
#endif /* _GTKMM_FRAME_H */

