// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_PANED_H
#define _GTKMM_PANED_H

#include <glibmm.h>

/* $Id: paned.hg,v 1.21 2002/04/02 13:25:19 daniel Exp $ */


/* paned.h
 * 
 * Copyright (C) 1998-1999 The gtkmm Development Team 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/container.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkPaned GtkPaned;
typedef struct _GtkPanedClass GtkPanedClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class Paned_Class; } // namespace Gtk
#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkHPaned GtkHPaned;
typedef struct _GtkHPanedClass GtkHPanedClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class HPaned_Class; } // namespace Gtk
#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkVPaned GtkVPaned;
typedef struct _GtkVPanedClass GtkVPanedClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class VPaned_Class; } // namespace Gtk
namespace Gtk
{

/** This is the base class for widgets with two panes, arranged either horizontally (Gtk::HPaned) or vertically (Gtk::VPaned). Child widgets are added to the panes of the widget with pack1() and pack2(). The division beween the two children is set by default from the size requests of the children, but it can be adjusted by the user.
 * A paned widget draws a separator between the two child widgets and a small handle that the user can drag to adjust the division. It does not draw any relief around the children or around the separator. Often, it is useful to put each child inside a Gtk::Frame with the shadow type set to GTK_SHADOW_IN so that the gutter appears as a ridge.
 * Each child has two options that can be set - resize and shrink. If resize is true, then when the GtkPaned is resized, that child will expand or shrink along with the paned widget. If shrink is true, then when that child can be made smaller than it's requisition. Setting shrink to false allows the application to set a minimum size. If resize is false for both children, then this is treated as if resize is true for both children.
 * The application can set the position of the slider as if it were set by the user, by calling set_position().
 *
 * @ingroup Widgets
 * @ingroup Containers
 */

class Paned : public Container
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Paned CppObjectType;
  typedef Paned_Class CppClassType;
  typedef GtkPaned BaseObjectType;
  typedef GtkPanedClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Paned();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType paned_class_;

  Paned(const Paned&);
  Paned& operator=(const Paned&); // not implemented

protected:
  explicit Paned(GtkPaned* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkPaned* gobj()             { return (GtkPaned*)(gobject_); }
  const GtkPaned* gobj() const { return (GtkPaned*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual bool on_cycle_child_focus(bool reverse);
  virtual bool on_toggle_handle_focus();
  virtual bool on_move_handle(ScrollType scroll);
  virtual bool on_cycle_handle_focus(bool reverse);
  virtual bool on_accept_position();
  virtual bool on_cancel_position();


private:

  
public:
  Paned();

  
  void add1(Widget& child);
  
  void add2(Widget& child);

  
  void pack1(Widget& child, bool resize, bool shrink);
  
  void pack2(Widget& child, bool resize, bool shrink);

  
  /** Obtains the position of the divider between the two panes.
   * @return Position of the divider.
   */
  int get_position() const;
  
  /** Sets the position of the divider between the two panes.
   * @param position Pixel position of divider, a negative value means that the position
   * is unset.
   */
  void set_position(int position);

  Widget* get_child1();
  const Widget* get_child1() const;
  Widget* get_child2();
  const Widget* get_child2() const;

  // Hey these are marked private! (but then their test program uses them!)
  // Message sent to gtk-devel about this. murrayc
  guint get_child1_shrink() const;
  guint get_child2_shrink() const;
  guint get_child1_resize() const;
  guint get_child2_resize() const;

  
  /**
   * @par Prototype:
   * <tt>bool %cycle_child_focus(bool reverse)</tt>
   */
  Glib::SignalProxy1<bool,bool> signal_cycle_child_focus();

  
  /**
   * @par Prototype:
   * <tt>bool %toggle_handle_focus()</tt>
   */
  Glib::SignalProxy0<bool> signal_toggle_handle_focus();

  
  /**
   * @par Prototype:
   * <tt>bool %move_handle(ScrollType scroll)</tt>
   */
  Glib::SignalProxy1<bool,ScrollType> signal_move_handle();

  
  /**
   * @par Prototype:
   * <tt>bool %cycle_handle_focus(bool reverse)</tt>
   */
  Glib::SignalProxy1<bool,bool> signal_cycle_handle_focus();

  
  /**
   * @par Prototype:
   * <tt>bool %accept_position()</tt>
   */
  Glib::SignalProxy0<bool> signal_accept_position();

  
  /**
   * @par Prototype:
   * <tt>bool %cancel_position()</tt>
   */
  Glib::SignalProxy0<bool> signal_cancel_position();


  Glib::PropertyProxy<int> property_position();

  Glib::PropertyProxy<bool> property_position_set();


};

/** @ingroup Widgets
 */

class HPaned : public Paned
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef HPaned CppObjectType;
  typedef HPaned_Class CppClassType;
  typedef GtkHPaned BaseObjectType;
  typedef GtkHPanedClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~HPaned();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType hpaned_class_;

  HPaned(const HPaned&);
  HPaned& operator=(const HPaned&); // not implemented

protected:
  explicit HPaned(GtkHPaned* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkHPaned* gobj()             { return (GtkHPaned*)(gobject_); }
  const GtkHPaned* gobj() const { return (GtkHPaned*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
  HPaned();
  

};

/** @ingroup Widgets
 */

class VPaned : public Paned
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef VPaned CppObjectType;
  typedef VPaned_Class CppClassType;
  typedef GtkVPaned BaseObjectType;
  typedef GtkVPanedClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~VPaned();

private:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  friend class CppClassType;
  static CppClassType vpaned_class_;

  VPaned(const VPaned&);
  VPaned& operator=(const VPaned&); // not implemented

protected:
  explicit VPaned(GtkVPaned* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkVPaned* gobj()             { return (GtkVPaned*)(gobject_); }
  const GtkVPaned* gobj() const { return (GtkVPaned*)(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
  VPaned();
  

};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Paned */
  Gtk::Paned* wrap(GtkPaned* object, bool take_copy = false);
}
namespace Glib
{
  /** @relates Gtk::HPaned */
  Gtk::HPaned* wrap(GtkHPaned* object, bool take_copy = false);
}
namespace Glib
{
  /** @relates Gtk::VPaned */
  Gtk::VPaned* wrap(GtkVPaned* object, bool take_copy = false);
}
#endif /* _GTKMM_PANED_H */

