// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_TREESTORE_H
#define _GTKMM_TREESTORE_H

#include <glibmm.h>

/* $Id: treestore.hg,v 1.22 2002/04/02 13:25:20 daniel Exp $ */

/* treestore.h
 * 
 * Copyright(C) 1998-1999 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <glibmm/object.h>
#include <gtkmm/treeiter.h>
#include <gtkmm/treemodel.h>
#include <gtkmm/treesortable.h>
#include <gtkmm/treedragdest.h>
#include <gtkmm/treedragsource.h>
#include <glibmm/arrayhandle.h>
#include <glibmm/value.h>
#include <gtk/gtktreestore.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
//typedef struct _GtkTreeStore GtkTreeStore;
//typedef struct _GtkTreeStoreClass GtkTreeStoreClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

namespace Gtk
{ class TreeStore_Class; } // namespace Gtk
namespace Gtk
{

/**
 * @ingroup TreeView
*/

class TreeStore
 : public Glib::Object,
   public Gtk::TreeModel,
   public TreeSortable,
   public TreeDragSource,
   public TreeDragDest
{
   public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef TreeStore          CppObjectType;
  typedef TreeStore_Class    CppClassType;
  typedef GtkTreeStore           BaseObjectType;
  typedef GtkTreeStoreClass      BaseClassType;

private:
  friend class CppClassType;
  static CppClassType treestore_class_;

  TreeStore(const TreeStore&);
  TreeStore& operator=(const TreeStore&); // not implemented

protected:
  explicit TreeStore(GtkTreeStore* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TreeStore();

  static Glib::RefPtr<TreeStore> wrap_specific_type(GtkTreeStore* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GtkTreeStore* gobj()             { return (GtkTreeStore*)(gobject_); }
  const GtkTreeStore* gobj() const { return (GtkTreeStore*)(gobject_); }

  GtkTreeStore* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

   
protected:
  explicit TreeStore(const TreeModelColumnRecord& columns);

public:
  
  static Glib::RefPtr<TreeStore> create(const TreeModelColumnRecord& columns);


  TreeIter erase(const TreeIter& iter);
  TreeIter insert(const TreeIter& iter);

  TreeIter prepend();
  TreeIter prepend(const TreeIterChildren& node);

  TreeIter append();
  TreeIter append(const TreeIterChildren& node);

  template <class ColumnType>
  void set_value(const TreeIter& row, const ColumnType& column,
                 const typename ColumnType::ElementType& data);

  
  /** Removes all rows from @a tree_store
   */
  void clear();
  
  /** Returns <tt>true</tt> if @a iter is an ancestor of @a descendant.  That is, @a iter is the
   * parent (or grandparent or great-grandparent) of @a descendant.
   * @param iter A valid Gtk::TreeIter.
   * @param descendant A valid Gtk::TreeIter.
   * @return <tt>true</tt>, if @a iter is an ancestor of @a descendant.
   */
  bool is_ancestor(const TreeIter& iter, const TreeIter& descendant);
  
  /** Returns the depth of @a iter.  This will be 0 for anything on the root level, 1
   * for anything down a level, etc.
   * @param iter A valid Gtk::TreeIter.
   * @return The depth of @a iter.
   */
  int iter_depth(const TreeIter& iter);

protected:
  
  /** Sets the data in the cell specified by @a iter and @a column.
   * The type of @a value must be convertible to the type of the
   * column.
   * @param iter A valid Gtk::TreeIter for the row being modified.
   * @param column Column number to modify.
   * @param value New value for the cell.
   */
  void set_value_impl(const TreeIter& row, int column, const Glib::ValueBase& value);


};


template <class ColumnType>
void TreeStore::set_value(const TreeIter& row, const ColumnType& column,
                          const typename ColumnType::ElementType& data)
{
  typename ColumnType::ValueType value;
  value.init(column.type());

  value.set(data);
  set_value_impl(row, column.index(), value);
}

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::TreeStore */
  Glib::RefPtr<Gtk::TreeStore> wrap(GtkTreeStore* object, bool take_copy = false);
}


#endif /* _GTKMM_TREESTORE_H */

