dnl
dnl _VFUNC_PH(gtkname, crettype, cargs and names)
dnl Create a callback and set it in our derived G*Class.
dnl
define(`_VFUNC_PH',`dnl
_PUSH(SECTION_PCC_CLASS_INIT_VFUNCS)
  klass->$1 = `&'$1_vfunc_callback;
_SECTION(SECTION_PH_VFUNCS)
  static $2 $1_vfunc_callback`'($3);
_POP()')


dnl               $1      $2       $3        $4
dnl _VFUNC_PCC(cppname,gtkname,cpprettype,crettype,
dnl                        $5                $6          $7            $8
dnl                  `<cargs and names>',`<cnames>',`<cpparg names>',firstarg)
dnl
define(`_VFUNC_PCC',`dnl
_PUSH(SECTION_PCC_VFUNCS)
$4 __CPPNAME__`'_Class::$2_vfunc_callback`'($5)
{
dnl  We cast twice to allow for multiple-inheritance casts, which might 
dnl  change the value.  We have to use a dynamic_cast because we do not 
dnl  know the actual type from which to cast up.
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper`'((GObject*)$8));

_IMPORT(SECTION_CHECK)
  if(obj)
  {
    try
    {
ifelse($4,void,`dnl
      obj->$1`'($7);
',`dnl
      return _CONVERT($3,$4,`obj->$1`'($7)');
')dnl
    }
    catch(...)
    {
      Glib::exception_handlers_invoke`'();
    }
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
ifdef(`__BOOL_IS_INTERFACE__',`dnl
        _IFACE_PARENT_FROM_OBJECT($8)dnl
',`dnl
        _PARENT_GCLASS_FROM_OBJECT($8)dnl
'));
    g_assert(base != 0);

    if(base->$2)
      (*base->$2)`'($6);
  }
ifelse($4,void,,`dnl

  typedef $4 RType;
  return RType`'();
')dnl
}

_POP()')


#                $1      $2       $3
# _VFUNC_H(vfunc_name,rettype,`<cppargs>')
#
define(`_VFUNC_H',`dnl
_PUSH(SECTION_H_VFUNCS)
  virtual $2 $1`'($3);
_POP()')

#                $1        $2        $3           $4          $5            $6
# _VFUNC_CC(vfunc_name, gtkname, cpp_rettype, c_rettype, `<cppargs>', `<carg_names>')
#
define(`_VFUNC_CC',`dnl
_PUSH(SECTION_CC_VFUNCS)
$3 __NAMESPACE__::__CPPNAME__::$1`'($5)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
ifdef(`__BOOL_IS_INTERFACE__',`dnl
      _IFACE_PARENT_FROM_OBJECT(gobject_)dnl
',`dnl
      _PARENT_GCLASS_FROM_OBJECT(gobject_)dnl
'));
  g_assert(base != 0);

  if(base->$2)
ifelse($3,void,`dnl
    (*base->$2)`'(gobj()`'_COMMA_PREFIX($6));
',`dnl
    return _CONVERT($4,$3,`(*base->$2)`'(gobj`'()`'_COMMA_PREFIX($6))');

  typedef $3 RType;
  return RType`'();
')dnl
}

_POP()')


#                        $1         $2         $3       $4          $5         $6
# _VFUNC_INTERFACE_H(vfunc_name, cpp_rettype,c_retype,`<cppargs>',`<cargs>',const)
# For Interfaces only: Adds the vfunc, with a _vfunc suffix,
# and the non-virtual wrapper with the normal name, and C++ types.
#
define(`_VFUNC_INTERFACE_H',`dnl
_VFUNC_H($1`'_vfunc,$3,`$5')
_VFUNC_CPPWRAPPER_H($1,$2,`$4',$6)
')

#                         $1          $2       $3          $4          $5            $6             $7          $8           $9
# _VFUNC_INTERFACE_CC(vfunc_name, gtkname, cpp_rettype, c_retype, `<cppargs>', `<cargs>', `<carg_names>', `<cpp_to_c_args>',const)
# For Interfaces only: Adds the vfunc, with a _vfunc suffix,
# and the non-virtual wrapper with the normal name.
#
define(`_VFUNC_INTERFACE_CC',`dnl
_VFUNC_CC($1`'_vfunc,$2,$4,$4,`$6',`$7')
_VFUNC_CPPWRAPPER_CC($1,$2,$3,$4,`$5',`$8',$9)
')

#                          $1      $2       $3       $4
# _VFUNC_CPPWRAPPER_H(vfunc_name,rettype,`<cppargs>',const)
#
define(`_VFUNC_CPPWRAPPER_H',`dnl
_PUSH(SECTION_H_VFUNCS_CPPWRAPPER)
  $2 $1`'($3)ifelse(`$4',1,` const');
_POP()')


#                           $1        $2         $3          $4          $5          $6      $7
# _VFUNC_CPPWRAPPER_CC(vfunc_name, gtkname, cpp_rettype, c_retype, `<cppargs>',`<carg_names>',const)
#
#
define(`_VFUNC_CPPWRAPPER_CC',`dnl
_PUSH(SECTION_CC_VFUNCS_CPPWRAPPER)
$3 __NAMESPACE__::__CPPNAME__::$1`'($5)ifelse(`$7',1,` const')
{
ifelse($3,void,`dnl
  ifelse(`$7',1,const_cast<__CPPNAME__*>(this)->,)$1`'_vfunc`'($6);
',`dnl
  return _CONVERT($4,$3,'ifelse(`$7',1,const_cast<__CPPNAME__*>(this)->,)`$1`_vfunc`'($6)');
') dnl
}

_POP()')

